



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Yii2 设计模式——工厂方法模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Yii2 设计模式——工厂方法模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 21:40:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>工厂方法模式</p>
<h6>模式定义</h6>
<p>工厂方法模式(Factory Method Pattern)定义了一个创建对象的接口，但由子类决定要实例化的类是哪一个。工厂方法让类吧实例化推迟到子类。</p>
<p>什么意思？说起来有这么几个要点：</p>
<ul><li>对象不是直接new产生，而是交给一个类方法去完成。比如loadTableSchema()方法</li></ul>
<ul><li>这个方法是抽象的，且必须被子类所实现</li>
<li>这个提供实例的抽象方法需要参与到其他逻辑中，去完成另一项功能。比如loadTableSchema()方法出现在getTableSchema()方法中，参与实现获取数据表元数据的功能</li></ul>
<h6>认识工厂方法模式</h6>
<p>所有的工厂模式都是用来封装对象的创建。工厂方法模式通过让子类来决定创建的对象是什么，从而达到将对象创建的过程封装的目的。</p>
<h4>应用举例</h4>
<p>yii\db\Schema抽象类中：</p>
<div>
<pre class="prettyprint linenums">//获取数据表元数据<br />
public function getTableSchema($name, $refresh = false)<br />
{<br />
    if (array_key_exists($name, $this-&gt;_tables) &amp;&amp; !$refresh) {<br />
        return $this-&gt;_tables[$name];<br />
    }

    $db = $this-&gt;db;<br />
    $realName = $this-&gt;getRawTableName($name);

    if ($db-&gt;enableSchemaCache &amp;&amp; !in_array($name, $db-&gt;schemaCacheExclude, true)) {<br />
        /* @var $cache Cache */<br />
        $cache = is_string($db-&gt;schemaCache) ? Yii::$app-&gt;get($db-&gt;schemaCache, false) : $db-&gt;schemaCache;<br />
        if ($cache instanceof Cache) {<br />
            $key = $this-&gt;getCacheKey($name);<br />
            if ($refresh || ($table = $cache-&gt;get($key)) === false) {<br />
                //通过工厂方法loadTableSchema()去获取TableSchema实例<br />
                $this-&gt;_tables[$name] = $table = $this-&gt;loadTableSchema($realName);<br />
                if ($table !== null) {<br />
                    $cache-&gt;set($key, $table, $db-&gt;schemaCacheDuration, new TagDependency([<br />
                        'tags' =&gt; $this-&gt;getCacheTag(),<br />
                    ]));<br />
                }<br />
            } else {<br />
                $this-&gt;_tables[$name] = $table;<br />
            }

            return $this-&gt;_tables[$name];<br />
        }<br />
    }<br />
    //通过工厂方法loadTableSchema()去获取TableSchema实例<br />
    return $this-&gt;_tables[$name] = $this-&gt;loadTableSchema($realName);<br />
}

//获取TableSchema实例，让子类去实现<br />
abstract protected function loadTableSchema($name);
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8oj4m1q.html">【JavaScript】JS 中 原始字符串 和 HTML 字符转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kjrx69.html">用pageGroup&period;js实现分页功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r4mn78.html">Memcache之telnet操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvrr6x8.html">ASP&period;NET MVC过滤器中权限过滤器ValidateAntiForgeryToken的用法（Post-Only&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq12wk09.html">Oracle参数化查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn6pvx9.html">ACM spiral grid</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qneev3q.html">CPU cache</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnwygv8.html">EL表达式&comma;JSTL：jsp standard Tag Library</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeo5o09.html">android stuido 在线安装svn插件，添加版本库无响应</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y1r40q.html">linux svn启动和关闭&lpar;转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zzylk9.html">解决一bug的流程复盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z36ge9.html">Python元编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkeln8.html">【Spring源码分析】AOP源码解析（上篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpx7559.html">4&period;DHCP与PRE</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvze28.html">去除input&lbrack;type&equals;number&rsqb;的默认样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdeyyv9.html">linux和windows下，C&sol;C&plus;&plus;开发的延时函数，sleep函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5klg4q.html">Linux（以RHEL7为例）下添加工作区的方法&vert;&vert; The Way To Add Workspace On Linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1w4vxq.html">InfluxDB、grafana、collect部署监控（centos6&period;8）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j5yenq.html">网络流24题 第五题 - PowerOJ1740  CodeVS1905 圆桌问题  二分图多重匹配  网络最大流</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2wnyy9.html">winform窗体启动过程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7ox4og8.html">以太坊Bootstrap和Kademlia算法实现逻辑简介（基于cpp-ethereum）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj1lpz9.html">查询数据库游标使用情况以及sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv25xly9.html">python的列表生成式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw06lj9.html">springboot源码之（内嵌tomcat）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wo0lzq.html">codeforces 1140D&lpar;区间dp&sol;思维题&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gx0e0q.html">WeX5学习笔记-02</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e41mem9.html">css缩放的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j10ejg9.html">iBATIS 调试</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jy4m0q.html">Findout之为什么公司内部不能使用SSH协议连接外网服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rzpk48.html">centos7 &comma;windows7 grub2 双系统引导</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
